<?php

/*
 * addadmin.php
 * Last modified: Mon Jan 22 16:58:40 CET 2007
 *
 * This script adds admins to the database
 * Admins are required to view the userlist, making actions, etc.
 *
 */

// Required db config PEAR::DB
require("connect.php");

// Include login check
include("check.php");

// Show only if logged in
if($logged_in == 1) {

// If data was submitted
if(isset($_POST['submit'])) {
	
	// Check required fields
	if(!$_POST['username'] | !$_POST['password'] | !$_POST['password_confirm'] | !$_POST['email'] | !$_POST['firstname'] | !$_POST['lastname']) {
		die("Please fill all required fields!");
	}

	// Check whether the name exists already
	$name_check = $db->query("SELECT username FROM admins WHERE username = '".$_POST['username']."'");

	if(MDB2::isError($name_check)) {
		die($name_check->getMessage());
	}

	$name_check2 = $name_check->numRows();

	if($name_check2 != 0) {
		die("Sorry, username is already taken. Please choose another one.");
	}

	// No HTML tags for username or password
	if(preg_match("/(\<|\>)/", $_POST['username']) | preg_match("/(\<|\>)/", $_POST['password'])) {
		die("Invalid input, no HTML tags are allowed!");
	}

	// Check if passwords match
	if($_POST['password'] != $_POST['password_confirm']) {
		die("Passwords did not match!");
	}

	// For our db, md5 is OK
	$_POST['password'] = md5($_POST['password']);

	if(!get_magic_quotes_gpc()) {
		$_POST['password'] = addslashes($_POST['password']);
		$_POST['email'] = addslashes($_POST['email']);
	}

	// Check mail regexp
	if (!preg_match("/.*@.*..*/", $_POST['email']) || preg_match("/(<|>)/", $_POST['email'])) {
		die("Invalid Email Format!");
	}
	
	// Date format
	// Y = year; m = month; d = day
	// H = hour; i = minute
	$date = date("Y.m.d H:i");

	// The MySQL query
	$insert = "INSERT INTO admins (username, password, firstname, lastname, email, regdate, lastlogin, ipaddress) VALUES ('".$_POST['username']."', '".$_POST['password']."', '".$_POST['firstname']."', '".$_POST['lastname']."', '".$_POST['email']."', '".$date."', 'Never', '0.0.0.0')";

	$add_member = $db->query($insert);

	if(MDB2::isError($add_member)) {
		die($add_member->getMessage());
	}

	@header("Location: admin.php");
	exit;

} else {

// If not data was submitted

include("header.inc.php");

?>

<form method="post" action="<?php echo $PHP_SELF;?>" name="form1">
<table width="600" class="base" bgcolor="#ffffff" cellpadding="2" cellspacing="1">
 <tr>
  <th colspan="2" align="left">&nbsp;Add Admin User</th>
 </tr>
 <tr>
  <td align="right" width="50%"><b>Username:</b></td>
  <td align="left" width="50%"><input type="text" name="username" maxlength="50" size="40"></td>
 </tr>
 <tr>
  <td align="right" width="50%"><b>Password:</b></td>
  <td align="left" width="50%"><input type="password" name="password" maxlength="40" size="40"></td>
 </tr>
 <tr>
  <td align="right" width="50%"><b>Password confirm:</b></td>
  <td align="left" width="50%"><input type="password" name="password_confirm" maxlength="40" size="40"></td>
 </tr>
 <tr>
  <td align="right" width="50%"><b>First Name:</b></td>
  <td align="left" width="50%"><input type="text" name="firstname" maxlength="50" size="40"></td>
 </tr>
 <tr>
  <td align="right" width="50%"><b>Last Name:</b></td>
  <td align="left" width="50%"><input type="text" name="lastname" maxlength="50" size="40"></td>
 </tr>
 <tr>
  <td align="right" width="50%"><b>Email:</b></td>
  <td align="left" width="50%"><input type="text" name="email" maxlength="80" size="40"></td>
 </tr>
 <tr>
  <td align="center" colspan="2"><input type="submit" name="submit" value="Submit">&nbsp;<input type="reset" name="reset" value="Reset"></td>
 </tr>
</table>
</form>

<?php

}

include("footer.inc.php");

} else {

	// Redirect if not logged in
	@header("Location: index.php");
	exit;

}

?>
