<?php

/*
 * getuser.php
 * Last modified: Mon Jan 22 16:40:10 CET 2007
 *
 * This is the file, where all the user actions will be processed
 * such as view, edit, change password, disable user and delete user
 *
 */

// Require db config PEAR::DB
require("connect.php");

// Include login check
include("check.php");

// If logged in
if($logged_in == 1) {

// If data was submitted from the edit page
if(isset($_POST['submit_edit'])) {

	// Check whether required fields are empty
	if(!$_POST['user'] || !$_POST['uid'] || !$_POST['gid'] || !$_POST['dir']) {
		die("Please fill in all required fields.");
	}

	$_POST['user'] = strip_tags($_POST['user']);

	// Update db with edited info
	$update = "UPDATE users SET user = '".$_POST['user']."', uid = '".$_POST['uid']."', gid = '".$_POST['gid']."', dir = '".$_POST['dir']."', userip = '".$_POST['userip']."', quotasize = '".$_POST['quotasize']."', ulbandwidth = '".$_POST['ulbandwidth']."', dlbandwidth = '".$_POST['dlbandwidth']."' WHERE user = '".$_POST['id']."'";
	$update_user = $db->query($update);

	if(MDB2::isError($update_user)) {
		die($update_user->getMessage());
	}

	$db->disconnect();

	// Redirect if finished
	@header("Location: listftpusers.php");
	exit;

}

// If password was changed
if(isset($_POST['submit_pwd'])) {
	
		// Check for required fields
		if(!$_POST['password'] || !$_POST['password_confirm']) {
			die("Please fill in all required fields.");
		}

		// New password can't contain invalid characters neither
		// For info, look at addftpuser.php
		$regexp_pass = "/^[a-zA-Z0-9\-_\.\[\]\{\}@:,%\^\&\*]{8,128}+$/i";
		
	    if(!preg_match($regexp_pass, $_POST['password'])) {
	        die("Password contains invalid characters. It can contain only following characters: a-z A-Z 0-9 - _ . [ ] { } @ : , % ^ & *");
	    }

		// Check if submitted passwords match
		if($_POST['password'] != $_POST['password_confirm']) {
			die("Passwords did not match!");
		}

		// Encrypt passwords with the crypt() function, for other
		// types look at your pureftpd's mysql.conf
		$_POST['password'] = crypt($_POST['password']);

		// Update database with new passwords
		$insert = "UPDATE users SET password = '".$_POST['password']."' WHERE user = '".$_POST['user']."'";

		$newpass = $db->query($insert);

		if(MDB2::isError($newpass)) {
			die($newpass->getMessage());
		}

		// Disconnect from db
		$db->disconnect();

		@header("Location: listftpusers.php");
		exit;
}

// If status is processed => enable or disable a user
if($_GET['a'] == "chgst") {

	// Update db with new status (new status is in the $_GET['status']
	$change = "UPDATE users SET status = '".$_GET['status']."' WHERE user = '".$_GET['user']."'";
	$change_status = $db->query($change);

	if(MDB2::isError($change_status)) {
		die($change_status->getMessage());
	}

	// Disconnect from db
	$db->disconnect();

	@header("Location: listftpusers.php");
	exit;

}

if($_GET['a'] == "delete") {

	// The MySQL query for deleting a user
	$delete = "DELETE FROM users WHERE user = '".$_GET['user']."'";
	$delete_user = $db->query($delete);

	if(MDB2::isError($delete_user)) {
		die($delete_user->getMessage());
	}

	// Disconnect from db
	$db->disconnect();

	// Redirect if done
	@header("Location: listftpusers.php");
	exit;

}

// For viewing user info from db
if($_GET['a'] == "view") {

	// The MySQL query
	$query = "SELECT * FROM users WHERE user = '".$_GET['user']."'";
	$query_user = $db->query($query);

	if(MDB2::isError($query_user)) {
		die($query_user->getMessage());
	}
		
	// Fetch into array
	$row = $query_user->fetchRow(DB_FETCHMODE_ASSOC);
	
	if($row['status'] == "1") { $stimg = "enable.png"; $alt = "Enable"; }
	if($row['status'] == "0") { $stimg = "disable.png"; $alt = "Disable"; }
		
	// Show user info in HTML
	include("header.inc.php");
	echo '<table width="600" class="base" align="center" cellpadding="3" cellspacing="1"">';
	echo '<tr><th align="left" colspan="2">User data of '.$row['user'].'</th></tr>';
	echo '<tr>';
	echo '<td align="right" width="50%">Username</td>';
	echo '<td align="left" width="50%">'.$row['user'].'</td>';
	echo '</tr>';
	echo '<tr>';
	echo '<td align="right" width="50%">UID</td>';
	echo '<td align="left" width="50%">'.$row['uid'].'</td>';
	echo '</tr>';
	echo '<tr>';
	echo '<td align="right" width="50%">GID</td>';
	echo '<td align="left" width="50%">'.$row['gid'].'</td>';
	echo '</tr>';
	echo '<tr>';
	echo '<td align="right" width="50%">Home Dir</td>';
	echo '<td align="left" width="50%">'.$row['dir'].'</td>';
	echo '</tr>';
	echo '<tr>';
	echo '<td align="right" width="50%">User IP</td>';
	echo '<td align="left" width="50%">'.$row['userip'].'</td>';
	echo '</tr>';
	echo '<tr>';
	echo '<td align="right" width="50%">Status</td>';
	echo '<td align="left" width="50%"><img src="/images/'.$stimg.'" alt="" border="0">&nbsp;&nbsp;'.$alt.'</td>';
	echo '</tr>';
	echo '<tr>';
	echo '<td align="right" width="50%">Quota</td>';
	echo '<td align="left" width="50%">'.$row['quotasize'].'</td>';
	echo '</tr>';
	echo '<tr>';
	echo '<td align="right" width="50%">Quota Files</td>';
	echo '<td align="left" width="50%">'.$row['quotafiles'].'</td>';
	echo '</tr>';
	echo '<tr>';
	echo '<td align="right" width="50%">Upload</td>';
	echo '<td align="left" width="50%">'.$row['ulbandwidth'].'</td>';
	echo '</tr>';
	echo '<tr>';
	echo '<td align="right" width="50%">Download</td>';
	echo '<td align="left" width="50%">'.$row['dlbandwidth'].'</td>';
	echo '</tr>';
	echo '<tr>';
	echo '<td align="right" width="50%">Upload Ratio</td>';
	echo '<td align="left" width="50%">'.$row['ulratio'].'</td>';
	echo '</tr>';
	echo '<tr>';
	echo '<td align="right" width="50%">Download Ratio</td>';
	echo '<td align="left" width="50%">'.$row['dlratio'].'</td>';
	echo '</tr>';
	echo '<tr>';
	echo '<td align="right" width="50%">Comment</td>';
	echo '<td align="left" width="50%">'.$row['comment'].'</td>';
	echo '</tr>';
	echo '<tr>';
	echo '<td colspan="2" align="center"><input type="button" name="back" value="Back" OnClick="javascript:history.back()"></td>';
	echo '</tr>';
	echo '</table>';
	echo '<br>';
	include("footer.inc.php");
}

// For user's password change
if($_GET['a'] == "pwd") {

	// The MySQL query
	$query = "SELECT * FROM users WHERE user = '".$_GET['user']."'";
	$query_user = $db->query($query);

	if(MDB2::isError($query_user)) {
		die($query_user->getMessage());
	}
		
	// Fetch into array
	$row = $query_user->fetchRow(DB_FETCHMODE_ASSOC);
		
	// Show change password form
	include("header.inc.php");
	echo '<form name="changepassword" method="post" action="'.$PHP_SELF.'">';
	echo '<table width="600" class="base" align="center" cellpadding="3" cellspacing="1">';
	echo '<tr><th align="left" colspan="2">Change password of <b>'.$row['user'].'</b></th></tr>';
	echo '<tr>';
	echo '<td align="right" width="50%">Username</td>';
	echo '<td align="left" width="50%">'.$row['user'].'</td>';
	echo '</tr>';
	echo '<tr>';
	echo '<td align="right" width="50%">New password</td>';
	echo '<td align="left" width="50%"><input type="password" name="password" size="20" maxlength="20"></td>';
	echo '</tr>';
	echo '<tr>';
	echo '<td align="right" width="50%">Confirm new password</td>';
	echo '<td align="left" width="50%"><input type="password" name="password_confirm" size="20" maxlength="20"></td>';
	echo '</tr>';
	echo '<tr>';
	echo '<td colspan="2" align="center"><input type="button" name="back" value="Back" OnClick="javascript:history.back()">&nbsp;&nbsp;<input type="submit" name="submit_pwd" value="Change"><input type="hidden" name="user" value="'.$_GET['user'].'"></td>';
	echo '</tr>';
	echo '</table>';
	echo '</form>';
	echo '<br>';
	include("footer.inc.php");
}

// If user info will be edited
if($_GET['a'] == "edit") {

	// The MySQL query
	$query = "SELECT * FROM users WHERE user = '".$_GET['user']."'";
	$query_user = $db->query($query);

	if(MDB2::isError($query_user)) {
		die($query_user->getMessage());
	}
		
	// Fetch into array
	$row = $query_user->fetchRow(DB_FETCHMODE_ASSOC);

	if($row['status'] == "1") {
   		$img = "disable.png";
   		$alt = "Disable";
   		$status = "0";
	} else {
	    $img = "enable.png";
   		$alt = "Enable";
		$user = " => User is disabled!";
   		$status = "1";
	}

	// Show edit user form
	include("header.inc.php");
	echo '<form name="edit" method="post" action="'.$PHP_SELF.'">';
	echo '<table width="600" class="base" align="center" cellpadding="3" cellspacing="1"">';
	echo '<tr><th align="left" colspan="2">User data of <b>'.$row['user'].' '.$user.'</b></th></tr>';
	echo '<tr>';
	echo '<td align="right" width="50%">Commands</td>';
	echo '<td align="left" width="50%"><a title="View user '.$row['user'].'" href="getuser.php?a=view&user='.$row['user'].'"><img src="images/view.png" border="0" alt="View"></a>&nbsp;
    <a title="Edit user '.$row['user'].'" href="getuser.php?a=edit&user='.$row['user'].'"><img src="images/edit.png" border="0" alt="Edit"></a>&nbsp;
    <a title="Change password of '.$row['user'].'" href="getuser.php?a=pwd&user='.$row['user'].'"><img src="images/locked.png" border="0" alt="Change Password"></a>&nbsp;
    <a title="'.$alt.' user '.$row['user'].'" href="getuser.php?a=chgst&status='.$status.'&user='.$row['user'].'"><img src="images/'.$img.'" alt="'.$alt.'" border="0"></a>&nbsp;
    <a title="Delete user '.$row['user'].'" href="getuser.php?a=delete&user='.$row['user'].'" OnClick="return confirm(\'Really delete user \\\''.$row['user'].'\\\' ?\')"><img src="images/delete.png" border="0" alt="Delete"></a></td>';
	echo '</tr>';
	echo '<tr>';
	echo '<td align="right" width="50%">Username</td>';
	echo '<td align="left" width="50%"><input type="text" name="user" size="20" maxlength="20" value="'.$row['user'].'"></td>';
	echo '</tr>';
	echo '<tr>';
	echo '<td align="right" width="50%">UID</td>';
	echo '<td align="left" width="50%"><input type="text" name="uid" size="20" maxlength="50" value="'.$row['uid'].'"></td>';
	echo '</tr>';
	echo '<tr>';
	echo '<td align="right" width="50%">GID</td>';
	echo '<td align="left" width="50%"><input type="text" name="gid" size="20" maxlength="50" value="'.$row['gid'].'"></td>';
	echo '</tr>';
	echo '<tr>';
	echo '<td align="right" width="50%">Home Dir</td>';
	echo '<td align="left" width="50%"><input type="text" name="dir" size="20" maxlength="50" value="'.$row['dir'].'"></td>';
	echo '</tr>';
	echo '<tr>';
	echo '<td align="right" width="50%">User IP</td>';
	echo '<td align="left" width="50%"><input type="text" name="userip" size="20" maxlength="50" value="'.$row['userip'].'"></td>';
	echo '</tr>';
	echo '<tr>';
	echo '<td align="right" width="50%">Quota</td>';
	echo '<td align="left" width="50%"><input type="text" name="quotasize" size="20" maxlength="50" value="'.$row['quotasize'].'"></td>';
	echo '</tr>';
	echo '<tr>';
	echo '<td align="right" width="50%">Quota Files</td>';
	echo '<td align="left" width="50%"><input type="text" name="quotafiles" size="20" maxlength="50" value="'.$row['quotafiles'].'"></td>';
	echo '</tr>';
	echo '<tr>';
	echo '<td align="right" width="50%">Upload</td>';
	echo '<td align="left" width="50%"><input type="text" name="ulbandwidth" size="20" maxlength="50" value="'.$row['ulbandwidth'].'"></td>';
	echo '</tr>';
	echo '<tr>';
	echo '<td align="right" width="50%">Download</td>';
	echo '<td align="left" width="50%"><input type="text" name="dlbandwidth" size="20" maxlength="50" value="'.$row['dlbandwidth'].'"></td>';
	echo '</tr>';
	echo '<tr>';
	echo '<td align="right" width="50%">Upload Ratio</td>';
	echo '<td align="left" width="50%"><input type="text" name="ulratio" size="20" maxlength="50" value="'.$row['ulratio'].'"></td>';
	echo '</tr>';
	echo '<tr>';
	echo '<td align="right" width="50%">Download Ratio</td>';
	echo '<td align="left" width="50%"><input type="text" name="dlratio" size="20" maxlength="50" value="'.$row['dlratio'].'"></td>';
	echo '</tr>';
	echo '<tr>';
	echo '<td align="right" width="50%" valign="top">Comment</td>';
	echo '<td align="left" width="50%"><textarea name="comment" cols="40" rows="3">'.$row['comment'].'</textarea></td>';
	echo '</tr>';
	echo '<tr>';
	echo '<td colspan="2" align="center"><input type="button" name="back" value="Back" OnClick="javascript:history.back()">&nbsp;&nbsp;<input type="submit" name="submit_edit" value="Change"><input type="hidden" name="id" value="'.$row['user'].'"></td>';
	echo '</tr>';
	echo '</table>';
	echo '</form>';
	echo '<br>';
	include("footer.inc.php");
}

} else {

	// If not logged in
	// Redirect if not logged in
	@header("Location: index.php");
	exit;

}

?>
