<?

/*
 * logout.php
 * Last modified: Mon Jan 22 17:12:17 CET 2007
 *
 * This is the logout script, it destroys the session variables
 * when pushing the logout button and redirects to the main page
 *
 */

// Required db config PEAR::DB
require("connect.php");

// Include login check
include("check.php");

// If not logged just redirect
if($logged_in == 0) {
	@header("Location: index.php");
	exit;
}

// Unset some session variables
unset($_SESSION['username']);
unset($_SESSION['password']);

$_SESSION = array();

// Destroy the session
session_destroy();

// Redirect if done
@header("Location: index.php?q=logout");
exit;

?>
